#include <netinet/in.h>

/* config globals */
extern char *multicastaddr;
extern int multicastport;
extern int multicasttl;
extern int verbose;
extern char *playlistfile;
extern char *recentlyplayedfile;
extern char *staticfile;
extern char *pidfilename;
extern int expire_pct;
extern int expire_per;

/* defines */
#define PACKETSIZE 1500 /* for rtppackets */
#define LINESIZE 1024 /* for playlistlines */
#define RECENTLINES 12

/* other globals */
int rtpsocket; /* socket outbound */
struct sockaddr_in rtptoaddr; /* destination */
int currentfile; /* current song */
int iBaseTime;

extern struct playlistentry *playlist;
extern unsigned int nr_entries;

/* datatypes */
struct rtpheader {
    int flags;
    int timestamp;
    int syncsource_id;
    int audioheader;
};

struct playlistentry {
   char *name;
   int weighted_pos;
};

struct pl_state {
  int i;
  int max_weight;
};

/* functions */
int iterate_db(DB *dbp, int (*cbf)(), void *arg);
int dbgp(int level, const char *format, ...);

